package provide mock_ns 1.7.2
namespace eval mock_ns {
    namespace export ns_log ns_logctl
}

proc mock_ns::ns_log {severity args} {
    
    # Mask anything in message that looks like a card number 
    set message [qc::format_cc_masked_string [join $args]]
    if { $severity ni [ns_logctl severities] } {
        # Do nothing
    } elseif { $severity in [list "App:Error" "Error"] } {
        # Write to stderr
        puts stderr "$severity - $message"
    } else {
        # Write to stdout
        puts stdout "$severity - $message"
    }
    
    return true
}

namespace eval mock_ns::ns_logctl {
    namespace export severity severities
    namespace ensemble create
    
    proc severity {severity args} {
        qc::args $args -color "" -intensity "" -- args
        variable severities_enabled
        qc::default severities_enabled [list]

        if { [llength $args] == 1 && [lindex $args 0] && $severity ni $severities_enabled } {
            # enable log severity
            lappend severities_enabled $severity
            
        } elseif { [llength $args] == 1 && ![lindex $args 0] && $severity in $severities_enabled} {
            # disable log severity
            set severities_enabled [qc::lexclude $severities_enabled $severity]
            
        } elseif { [llength $args] > 1 } {
            error "Invalid args for ns_logctl severity ?-color color? ?-intensity intensity? ?bool?"
        }

        return [qc::in $severities_enabled $severity]

    }

    proc severities {} {
        variable severities_enabled
        qc::default severities_enabled [list]
        
        return $severities_enabled
    }
}
