package provide mock_ns 1.7.2
namespace eval mock_ns {
    namespace export ns_register_filter ns_register_proc
}

proc mock_ns::ns_register_filter { args } {
    qc::args $args -first -- when http_method url script args

    if { $when ni [list preauth postauth trace] } {
        error [join [list \
                         "Unsupported \"when\" value for ns_register_filter." \
                         "Must be one of \"preauth\" \"postauth\" or \"trace\"" \
                        ]]
    }
    
    if { [nsv_exists "ns_register_filters" $when $http_method] } {
        set filters [nsv_get "ns_register_filters" $when $http_method]
    } else {
        set filters [list]
    }
    
    set filter [dict_from \
                    url \
                    script \
                    args \
                   ]
    
    if { [info exists first] } {
        nsv_set "ns_register_filters" $when $http_method \
            [linsert $filters 0 $filter]
    } else {
        nsv_set "ns_register_filters" $when $http_method \
            [lappend filters $filter]
    }
}

proc mock_ns::ns_register_proc { args } {
    qc::args $args -noinherit -- http_method url_pattern myproc args
    default noinherit false
    
    if { [nsv_exists "ns_register_procs" $http_method] } {
        set procs [nsv_get "ns_register_procs" $http_method]
    } else {
        set procs [list]
    }

    set url_pattern [string trimright $url_pattern "/"]

    dict set procs $noinherit $url_pattern [dict_from \
                                                myproc \
                                                args \
                                               ]
    
    nsv_set "ns_register_procs" $http_method $procs
}
