package provide mock_ns 1.7.2
namespace eval mock_ns {
    namespace export ns_return ns_write ns_returnredirect ns_returnfile
}

proc mock_ns::ns_return {status mime_type body} {
    variable mock_http_response_body $body
    ns_conn status $status
    ns_conn close

    return $body
}

proc mock_ns::ns_write {data args} {
    # update conn flags to indicate headers have been returned to client
    if { !([ns_conn flags] & 0x10) } {
        ns_conn _set flags [expr {
                                  [ns_conn flags]
                                  + 0x10
                              }]
    }

    variable mock_http_response_body
    append mock_http_response_body $data {*}$args
}

proc mock_ns::ns_returnredirect {url} {
    set outputheaders [ns_conn outputheaders]
    ns_set update $outputheaders Location $url
    ns_conn status 302
    ns_conn close
    
    return $url
}

proc mock_ns::ns_returnfile {status mime_type filepath} {
    if { ![file exists $filepath] } {
        error "File not found: \"$filepath\""
    }
    ns_conn status 200
    ns_conn close
    
    return $filepath
}
