package provide mock_ns 1.7.2
namespace eval mock_ns {
    namespace export nsv_exists nsv_get nsv_set nsv_unset nsv_lappend nsv_array
}

proc mock_ns::nsv_exists { args } {
    variable nsv
    if [info exists nsv] {
        return [dict exists $nsv {*}$args]
    } else {
        return false
    }
}

proc mock_ns::nsv_get { args } {
    variable nsv
    dict get $nsv {*}$args
}

proc mock_ns::nsv_set { args } {
    variable nsv
    dict set nsv {*}$args
}

proc mock_ns::nsv_unset { args } {
    variable nsv
    dict unset nsv {*}$args
}


proc mock_ns::nsv_lappend { array key args } {
    if { [nsv_exists $array $key] } {
        set value [nsv_get $array $key]
    } else {
        set value [list]
    }

    lappend value {*}$args
    
    nsv_set $array $key $value
}

namespace eval mock_ns::nsv_array {    
    namespace export exists names
    namespace ensemble create

    proc exists { array } {
        return [nsv_exists $array]        
    }

    proc names { array {pattern "*"} } {
        if { [exists $array] } {
            return [dict keys [nsv_get $array] $pattern]
        } else {
            return [list]
        }
    }
}
